local json = require("json")
local utils = require("utils")
local const = require("const")
local request_method = ngx.var.request_method

utils.check_login()
_, login_token = utils.check_permission("StreamCompute")

if "POST" == request_method then
    local utils_header = require("utils_header")
    local params = utils_header.check_public_boby_data()
    local taskNO  = params["TaskNO"]
    local taskContent = params["TaskContent"]

    if taskNO == nil or type(taskNO) ~= "string" or taskContent == nil or type(taskContent) ~= "string" then
        utils.error_exit(400, "TaskNO must not be null")
    end

    local cmd = {}

    cmd["id"] = taskNO
    cmd["content"] = taskContent

    local ok, msg_raw, err = utils.dbus_call_edge(const.stream_compute.wkn,
                                        const.stream_compute.obj,
                                        const.stream_compute.inf,
                                        const.stream_compute.method.saveJobCode,
                                        json.encode(cmd))

    local msg_ret = {}
    if (ok and msg_raw) then
        local ok, msg = pcall(json.decode, msg_raw[1])
        if not ok then
            utils.error_exit(500, json.encode(msg_raw[1]))
        end

        if msg ~= nil then
            msg["TaskNO"] = taskNO
        end
        local ret = {}
        ret["code"] = 200
        ret["data"] = msg
        ret["message"] = "success"
        if 0 ~= msg["code"] then
            ret["message"] = "failed"
        end
        ngx.say(json.encode(ret))
        ngx.flush(true)
        ngx.exit(ngx.HTTP_OK)
    else
        utils.error_exit(500, json.encode("failed to query: "..err))
    end

    utils.error_exit(200, json.encode(msg_ret))

end
utils.error_exit(400, "unsupported request method")
